##
## Copyright (c) 2006 Jason Dillon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##

##
## $Id: counters.py 26 2006-04-15 06:25:53Z user57 $
##

from p4spam.perforce import P4Field, P4Code, P4Exception
from p4spam.perforce.commands import StreamedResultCommand
from p4spam.perforce.commands.counter import CounterInfo

COMMAND_NAME = "counters"

##
## CountersCommand
##

class CountersCommand(StreamedResultCommand):
    def __init__(this, p4):
        StreamedResultCommand.__init__(this, COMMAND_NAME, p4)
    
    def createResult(this, entry):
        return CounterInfo(entry)

##
## perforce.commands factory interface
##

def create(p4):
    return CountersCommand(p4)

