##
## Copyright (c) 2006 Jason Dillon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##

##
## $Id: decode.py 25 2006-04-15 05:48:42Z user57 $
##

import marshal, sys

class P4OutputIterator:
    def __init__(this, inputFile):
        this.inputFile = inputFile
    
    def __iter__(this):
        return this
   
    def next(this):
        try:
            return marshal.load(this.inputFile)
        except EOFError:
            raise StopIteration

def dump(inputFile):
    iter = P4OutputIterator(inputFile)
    i = 0
    
    for entry in iter:
        i = i + 1
        print "--%d--" % (i)
        
        for key in entry.keys():
            print "%s: %s" % (key, entry[key])

if __name__ == '__main__':
    dump(sys.stdin)
